/*******************************************************************************
 * Copyright (c) 2000, 2003 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/cpl-v10.html
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
module dwt.accessibility.acc;


/**
 * Class ACC contains all the constants used in defining an
 * Accessible object.
 * 
 * @since 2.0
 */
public class ACC {
	public const int STATE_NORMAL = 0x00000000;
	public const int STATE_SELECTED = 0x00000002;
	public const int STATE_SELECTABLE = 0x00200000;
	public const int STATE_MULTISELECTABLE = 0x1000000;
	public const int STATE_FOCUSED = 0x00000004;
	public const int STATE_FOCUSABLE = 0x00100000;
	public const int STATE_PRESSED = 0x8;
	public const int STATE_CHECKED = 0x10;
	public const int STATE_EXPANDED = 0x200;
	public const int STATE_COLLAPSED = 0x400;
	public const int STATE_HOTTRACKED = 0x80;
	public const int STATE_BUSY = 0x800;
	public const int STATE_READONLY = 0x40;
	public const int STATE_INVISIBLE = 0x8000;
	public const int STATE_OFFSCREEN = 0x10000;
	public const int STATE_SIZEABLE = 0x20000;

	public const int ROLE_CLIENT_AREA = 0xa;
	public const int ROLE_WINDOW = 0x9;
	public const int ROLE_MENUBAR = 0x2;
	public const int ROLE_MENU = 0xb;
	public const int ROLE_MENUITEM = 0xc;
	public const int ROLE_SEPARATOR = 0x15;
	public const int ROLE_TOOLTIP = 0xd;
	public const int ROLE_SCROLLBAR = 0x3;
	public const int ROLE_DIALOG = 0x12;
	public const int ROLE_LABEL = 0x29;
	public const int ROLE_PUSHBUTTON = 0x2b;
	public const int ROLE_CHECKBUTTON = 0x2c;
	public const int ROLE_RADIOBUTTON = 0x2d;
	public const int ROLE_COMBOBOX = 0x2e;
	public const int ROLE_TEXT = 0x2a;
	public const int ROLE_TOOLBAR = 0x16;
	public const int ROLE_LIST = 0x21;
	public const int ROLE_LISTITEM = 0x22;
	public const int ROLE_TABLE = 0x18;
	public const int ROLE_TABLECOLUMN = 0x19;
	public const int ROLE_TREE = 0x23;
	public const int ROLE_TABFOLDER = 0x3c;
	public const int ROLE_TABITEM = 0x25;
	public const int ROLE_PROGRESSBAR = 0x30;
	public const int ROLE_SLIDER = 0x33;

	public const int CHILDID_SELF = -1;
	public const int CHILDID_NONE = -2;
	public const int CHILDID_MULTIPLE = -3;
	
	public const int TEXT_INSERT = 0;
	public const int TEXT_DELETE = 1;
}
