/*******************************************************************************
 * Copyright (c) 2000, 2003 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/cpl-v10.html
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/

/*******************************************************************************
 * DWT: SWT port for the D Language
 * 
 * Contributors:
 * 	The DWT team at http://www.dsource.org/projects/dwt
 * 
 *******************************************************************************/



module dwt.graphics.gcdata;

/+
import org.eclipse.swt.internal.win32.*;
+/

private import dwt.internal.win32.types;


/**
 * Instances of this class are descriptions of GCs in terms
 * of unallocated platform-specific data fields.
 * <p>
 * <b>IMPORTANT:</b> This class is <em>not</em> part of the public
 * API for SWT. It is marked public only so that it can be shared
 * within the packages provided by SWT. It is not available on all
 * platforms, and should never be called from application code.
 * </p>
 */

public final class GCData {
	private import dwt.graphics.device;
	private import dwt.graphics.image;
	public Device device;
	public int style;
	public Image image;
	public int foreground = -1;
	public int background = -1;
	public int hPen;
	public int hBrush;
	public int hFont;
	public int hNullBitmap;
	public int hwnd;
	public PAINTSTRUCT* ps;
	public int layout = -1;
}
