
MAX_ARGS = 12
MAX_CALLBACKS = 127

print '''/**
 * A way to map an extern(Windows) function to a D delegate.
 * Cooked up by the SWT guys. (it's smart!)
 *
 * This is generated by a python script.  Don't edit this file yourself.
 */

module dwt.internal.callback;'''

for argCount in range(MAX_ARGS):
    print '''
Function%i bind(Delegate%i proc) {
    foreach (int index, inout Delegate%i callback; delegate%i) {
        if (callback === null) {
            callback = proc;
            return function%i[index];
        }
    }
    assert(false);
    return null;
}

void unbind(Delegate%i proc) {
    foreach (inout Delegate%i callback; delegate%i) {
        if (callback === proc) {
            callback = null;
            return;
        }
    }
    assert(false);
}
'''.replace('%i', str(argCount))

print '''

private {
    const int MAX_ARGS=%i;
    const int MAX_CALLBACKS=%i;''' % (MAX_ARGS, MAX_CALLBACKS)

for argCount in range(MAX_ARGS):
    print '    Delegate%i[MAX_CALLBACKS] delegate%i;' % (argCount, argCount)

print

for argCount in range(MAX_ARGS):
    print '    Function%i[MAX_CALLBACKS] function%i;' % (argCount, argCount)

print

for argCount in range(MAX_ARGS):
    argList = ', '.join(['void* p%i' % i for i in range(argCount)])
    print '    alias int delegate(%s) Delegate%i;' % (argList, argCount)

print

for argCount in range(MAX_ARGS):
    argList = ', '.join(['void* p%i' % i for i in range(argCount)])
    print '    extern (Windows) alias int function(%s) Function%i;' % (argList, argCount)

print

for argCount in range(MAX_ARGS):
    for funcCount in range(MAX_CALLBACKS):
        print '    extern (Windows) int callback_arg%i_%i(%s) { return delegate%i[%i](%s); }' % (
            argCount,
            funcCount,
            ', '.join(['void* p%i' % i for i in range(argCount)]),
            argCount,
            funcCount,
            ', '.join(['p%i' % i for i in range(argCount)])
        )
    print


print '}'
