/*******************************************************************************
 * Copyright (c) 2000, 2003 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/cpl-v10.html
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/

/*******************************************************************************
 * DWT: SWT port for the D Language
 * 
 * Contributors:
 * 	The DWT team at http://www.dsource.org/projects/dwt
 * 
 *******************************************************************************/


module dwt.internal.win32.types;

//version = Unicode;

/*
 * win32 types and junk
 */

alias void* HINSTANCE;
alias void* HMENU;
alias void* HWND;
alias void* HBRUSH;
alias void* HBITMAP;
alias void* HBITMAP;

struct RECT {
    int left;
    int top;
    int right;
    int bottom;
}

struct POINT {
    int x;
    int y;
}

struct BITMAP {
	int bmType;
	int bmWidth;
	int bmHeight;
	int bmWidthBytes;
	short bmPlanes;
	short bmBitsPixel;
	byte* bmBits;
}

struct BITMAPINFOHEADER {
    uint  biSize;
    int   biWidth;
    int   biHeight;
    short   biPlanes;
    short   biBitCount;
    uint  biCompression;
    uint  biSizeImage;
    int   biXPelsPerMeter;
    int   biYPelsPerMeter;
    uint  biClrUsed;
    uint  biClrImportant;
}

struct GRADIENT_RECT {
    int UpperLeft;
    int LowerRight;
}

struct HELPINFO {
   public int cbSize;
   public int iContextType;
   public int iCtrlId;
   public int hItemHandle;
   public int dwContextId;
//   POINT MousePos
   public int x;
   public int y;
}

struct COMPOSITIONFORM {
	public int dwStyle;       
//	POINT ptCurrentPos;
	public int x, y;
//	RECT rcArea;  
	public int left, top, right, bottom;
}

struct DIBSECTION {
    BITMAP dsBm;
    BITMAPINFOHEADER bsBmih;
    uint[3] dsBitfields;
    uint dsSection;
    uint dsOffset;
}

struct FILETIME {
	int dwLowDateTime;
	int dwHighDateTime;
}

struct GCP_RESULTS {
	int lStructSize;
	int lpOutString;
	int lpOrder;
	int lpDx;
	int lpCaretPos;
	int lpClass;
	int lpGlyphs;
	int nGlyphs;
	int nMaxFit;
}

struct INITCOMMONCONTROLSEX {
	int dwSize; 
	int dwICC;
}

struct LOGBRUSH {
	int lbStyle;
	int lbColor;
	int lbHatch;
}

struct LOGPEN {
    uint lopnStyle;
    POINT lopnSize;
    uint lopnColor;
}

struct LVCOLUMN {
	int mask;
	int fmt;
	int cx;
	int pszText;
	int cchTextMax;
	int iSubItem;
	int iImage;
	int iOrder;
}

struct LVHITTESTINFO {
//	POINT pt;
	int x;
	int y;
	int flags;
	int iItem;
	int iSubItem;
}

struct LVITEM {
	int mask;
	int iItem;
	int iSubItem;
	int state;
	int stateMask;
	int pszText;
	int cchTextMax;
	int iImage;
	int lParam;
	int iIndent;
}

struct MENUINFO {
	int cbSize;
	int fMask;
	int dwStyle;
	int cyMax;
	int hbrBack;
	int dwContextHelpID;
	int dwMenuData;
}

struct MENUITEMINFO {
	int cbSize;
	int fMask;
	int fType;
	int fState;
	int wID;
	int hSubMenu;
	int hbmpChecked;
	int hbmpUnchecked;
	int dwItemData;
	int dwTypeData;
	int cch;
	int hbmpItem;
}

struct MONITORINFO {
	int cbSize;
//	RECT rcMonitor;
	int rcMonitor_left;
	int rcMonitor_top;
	int rcMonitor_right;
	int rcMonitor_bottom;
//	RECT rcWork;
	int rcWork_left;
	int rcWork_top;
	int rcWork_right;
	int rcWork_bottom;
	int dwFlags;
}

struct OPENFILENAME {
	int lStructSize;
	int hwndOwner;
	int hInstance;
	int lpstrFilter;
	int lpstrCustomFilter;
	int nMaxCustFilter;
	int nFilterIndex;
	int lpstrFile;
	int nMaxFile;
	int lpstrFileTitle;
	int nMaxFileTitle;
	int lpstrInitialDir;
	int lpstrTitle;
	int Flags;
	short nFileOffset;
	short nFileExtension;
	int lpstrDefExt;
	int lCustData;
	int lpfnHook;
	int lpTemplateName;
}

struct PRINTDLG {
	int lStructSize; // DWORD
	int hwndOwner; // HWND
	int hDevMode; // HGLOBAL
	int hDevNames; // HGLOBAL
	int hDC; // HDC
	int Flags; // DWORD
	short nFromPage; // WORD
	short nToPage; // WORD
	short nMinPage; // WORD
	short nMaxPage; // WORD
	short nCopies; // WORD
	int hInstance; // HINSTANCE
	int lCustData; // LPARAM
	int lpfnPrintHook; // LPPRINTHOOKPROC
	int lpfnSetupHook; // LPSETUPHOOKPROC
	int lpPrintTemplateName; // LPCTSTR
	int lpSetupTemplateName; // LPCTSTR
	int hPrintTemplate; // HGLOBAL
	int hSetupTemplate; // HGLOBAL
}

struct REBARBANDINFO {
	int cbSize;
	int fMask;
	int fStyle;
	int clrFore;
	int clrBack;
	int lpText;
	int cch;
	int iImage;
	int hwndChild;
	int cxMinChild;
	int cyMinChild;
	int cx;
	int hbmBack;
	int wID;
	int cyChild;  
	int cyMaxChild;
	int cyIntegral;
	int cxIdeal;
	int lParam;
	int cxHeader;
	/* Note in WinCE.  The field cxHeader is not defined. */ 
}

struct SIZE {
    int width;
    int height;
}

struct TBBUTTON {
	int iBitmap;
	int idCommand;
	byte fsState;
	byte fsStyle;
	int dwData;
	int iString;
}


struct TBBUTTONINFO {
	int cbSize;
	int dwMask;
	int idCommand;
	int iImage;
	byte fsState;
	byte fsStyle;
	short cx;
	int lParam;
	int pszText;
	int cchText;
}

struct TCITEM {
	int mask;
	int dwState;
	int dwStateMask;
	int pszText;
	int cchTextMax;
	int iImage;
	int lParam;
}

struct TOOLINFO {
	int cbSize; 
	int uFlags;
	int hwnd; 
	int uId; 
//	RECT rect;
	int left, top, right, bottom;
	int hinst; 
	int lpszText;
	int lParam;
}

struct TVHITTESTINFO {
//	POINT pt;
	int x;
	int y;
	int flags;
	int hItem;
}

struct TVINSERTSTRUCT {
	int hParent;
	int hInsertAfter;
//	TVITEM item;
	int mask;
	int hItem;
	int state;
	int stateMask;
	int pszText;
  	int cchTextMax;
  	int iImage;
  	int iSelectedImage;
	int cChildren;
	int lParam;
}

struct TVITEM {
	int mask;
	int hItem;
	int state;
	int stateMask;
	int pszText;
  	int cchTextMax;
  	int iImage;
  	int iSelectedImage;
	int cChildren;
	int lParam;
}

struct BROWSEINFO {
	int hwndOwner;
	int pidlRoot;
	int pszDisplayName;
	int lpszTitle;
	int ulFlags;
	int lpfn;
	int lParam;
	int iImage;
}

struct SHELLEXECUTEINFO {
	int cbSize;
	int fMask; 
	int hwnd;
	int lpVerb;
	int lpFile; 
	int lpParameters;
	int lpDirectory;
	int nShow; 
	int hInstApp;
	// Optional members
	int lpIDList; 
	int lpClass;
	int hkeyClass;
	int dwHotKey;
//	union {
//		HANDLE hIcon;		
//		HANDLE hMonitor;
//	};
	int hIcon;
	int hProcess; 
}

struct DOCINFO {
	int cbSize; 
	int lpszDocName; // LPCTSTR
	int lpszOutput; // LPCTSTR
	int lpszDatatype;// LPCTSTR
	int fwType; // DWORD
}














struct ACCEL {
	byte fVirt;
	short key;
	short cmd;
}

struct SHMENUBARINFO {
	int cbSize;
	int hwndParent;
	int dwFlags;
	int nToolBarId;
	int hInstRes;
	int nBmpId;
	int cBmpImages;
	int hwndMB;
}

struct SHRGINFO {
   public int cbSize;
   public int hwndClient;
//   POINT ptDown
   public int ptDown_x;
   public int ptDown_y;
   public int dwFlags;
}

struct SIPINFO {
   public int cbSize;
   public int fdwFlags;
//   RECT rcVisibleDesktop
   public int rcVisibleDesktop_left;
   public int rcVisibleDesktop_top;
   public int rcVisibleDesktop_right;
   public int rcVisibleDesktop_bottom;
//   RECT rcSipRect
   public int rcSipRect_left;
   public int rcSipRect_top;
   public int rcSipRect_right;
   public int rcSipRect_bottom;
   public int dwImDataSize;
   public int pvImData;
}

struct CREATESTRUCT {
    void*      lpCreateParams;
    HINSTANCE   hInstance;
    HMENU       hMenu;
    HWND        hwndParent;
    int         cy;
    int         cx;
    int         y;
    int         x;
    long        style;
    void*       lpszName;
    void*       lpszClass;
    uint        dwExStyle;
}

struct CREATESTRUCTA {
    void*      lpCreateParams;
    HINSTANCE   hInstance;
    HMENU       hMenu;
    HWND        hwndParent;
    int         cy;
    int         cx;
    int         y;
    int         x;
    long        style;
    char*       lpszName;
    char*       lpszClass;
    uint        dwExStyle;
}

struct CREATESTRUCTW {
    void*      lpCreateParams;
    HINSTANCE   hInstance;
    HMENU       hMenu;
    HWND        hwndParent;
    int         cy;
    int         cx;
    int         y;
    int         x;
    long        style;
    wchar*      lpszName;
    wchar*      lpszClass;
    uint        dwExStyle;
}

struct DLLVERSIONINFO {
	int cbSize;
	int dwMajorVersion;
	int dwMinorVersion;
	int dwBuildNumber;
	int dwPlatformID;
}

struct DRAWITEMSTRUCT {
	int CtlType;
	int CtlID;
	int itemID;
	int itemAction;
	int itemState;
	int hwndItem;
	int hDC;
// 	RECT rcItem;
	int left, top, bottom, right;
	int itemData;
}

struct ICONINFO {
	bool fIcon;
	int xHotspot;
	int yHotspot;
	int hbmMask;
	int hbmColor;
}

version(Unicode) {
	alias LOGFONTW LOGFONT;
} else {
	alias LOGFONTA LOGFONT;
}

struct LOGFONTA {
    int lfHeight;
    int lfWidth;
    int lfEscapement;
    int lfOrientation;
    int lfWeight;
    byte lfItalic;
    byte lfUnderline;
    byte lfStrikeOut;
    byte lfCharSet;
    byte lfOutPrecision;
    byte lfClipPrecision;
    byte lfQuality;
    byte lfPitchAndFamily;
    //char[OS.LF_FACESIZE] lfFaceName;
    char[32] lfFaceName;
    bool isValid;
}

struct LOGFONTW {
    int lfHeight;
    int lfWidth;
    int lfEscapement;
    int lfOrientation;
    int lfWeight;
    byte lfItalic;
    byte lfUnderline;
    byte lfStrikeOut;
    byte lfCharSet;
    byte lfOutPrecision;
    byte lfClipPrecision;
    byte lfQuality;
    byte lfPitchAndFamily;
    //wchar[OS.LF_FACESIZE] lfFaceName;
    wchar[32] lfFaceName;
    bool isValid;
}

// Yay D for not sucking
alias int LRESULT;

struct MEASUREITEMSTRUCT {
	int CtlType;
	int CtlID;
  	int itemID;
	int itemWidth;
	int itemHeight; 
	int itemData;
}

struct MSG {
	int hwnd;     
	int message; 
	int wParam; 
	int lParam; 
	int time; 
//	POINT pt;
	int x, y;
	static final int sizeof = 28;
}

struct NMHDR {
	int hwndFrom;
	int idFrom;
	int code;
}

/+
struct NMTTDISPINFO /*: NMHDR*/ {
    // nmhdr
    int hwndFrom;
    int idFrom;
    int code;

    int lpszText;
    int hinst;
    int uFlags;
    int lParam;
}
+/
version(Unicode) {
	alias NMTTDISPINFOW NMTTDISPINFO;
} else {
	alias NMTTDISPINFOA NMTTDISPINFO;
}
struct NMTTDISPINFOA {
    int hwndFrom;
    int idFrom;
    int code;
    int lpszText;
    int hinst;
    int uFlags;
    int lParam;

    char[80] szText;
}

class NMTTDISPINFOW {
    // nmhdr
    int hwndFrom;
    int idFrom;
    int code;
    int lpszText;
    int hinst;
    int uFlags;
    int lParam;

    wchar[80] szText;
}

//  With doing the version and alias for LOGFONT, the same thing is not necessary with this struct, as it can now
//	just use LOGFONT.

struct NONCLIENTMETRICS {
	int cbSize; 
	int iBorderWidth; 
	int iScrollWidth; 
	int iScrollHeight; 
	int iCaptionWidth; 
	int iCaptionHeight; 
	int iSmCaptionWidth; 
	int iSmCaptionHeight;
	int iMenuWidth; 
	int iMenuHeight;
	LOGFONT lfCaptionFont;
	LOGFONT lfSmCaptionFont; 
	LOGFONT lfMenuFont;
	LOGFONT lfStatusFont;
	LOGFONT lfMessageFont;
}

// the code still uses these in places
alias NONCLIENTMETRICS NONCLIENTMETRICSA;
alias NONCLIENTMETRICS NONCLIENTMETRICSW;

struct OSVERSIONINFO {
	int dwOSVersionInfoSize;
	int dwMajorVersion;
	int dwMinorVersion;
	int dwBuildNumber;
	int dwPlatformId;
}

struct OSVERSIONINFOA {
	int dwOSVersionInfoSize;
	int dwMajorVersion;
	int dwMinorVersion;
	int dwBuildNumber;
	int dwPlatformId;
	char[128] szCSDVersion;
}

struct OSVERSIONINFOW {
	int dwOSVersionInfoSize;
	int dwMajorVersion;
	int dwMinorVersion;
	int dwBuildNumber;
	int dwPlatformId;
	wchar[128] szCSDVersion;
}

struct PAINTSTRUCT {
	int  hdc;
	bool fErase;
//	RECT rcPaint;
	int left, top, right, bottom;

	bool fRestore;
	bool fIncUpdate;
	byte[32] rgbReserved;
}

struct SCROLLINFO {
	int cbSize;
	int fMask;
	int nMin;
	int nMax;
	int nPage;
	int nPos;
	int nTrackPos;
	static final int sizeof = 28;
}

struct SHACTIVATEINFO {
	int cbSize;
	int hwndLastFocus;
	int fSipUp; // :1
	int fSipOnDeactivation; // :1
	int fActive; // :1
	int fReserved; // :29
    // use SHACTIVATEINFO.size instead of sizeof
}

struct TRACKMOUSEEVENT {
   public int cbSize;
   public int dwFlags;
   public int hwndTrack;
   public int dwHoverTime;
   //public static final int sizeof = 16;
}

version(Unicode) {
	alias TEXTMETRICW TEXTMETRIC;
} else {
	alias TEXTMETRICA TEXTMETRIC;
}

struct TEXTMETRICA {
    int tmHeight;
    int tmAscent;
    int tmDescent;
    int tmInternalLeading;
    int tmExternalLeading;
    int tmAveCharWidth;
    int tmMaxCharWidth;
    int tmWeight;
    int tmOverhang;
    int tmDigitizedAspectX;
    int tmDigitizedAspectY;
    byte tmItalic;
    byte tmUnderlined;
    byte tmStruckOut;
    byte tmPitchAndFamily;
    byte tmCharSet;

    char tmFirstChar;
    char tmLastChar;
    char tmDefaultChar;
    char tmBreakChar;
}

struct TEXTMETRICW {
    int tmHeight;
    int tmAscent;
    int tmDescent;
    int tmInternalLeading;
    int tmExternalLeading;
    int tmAveCharWidth;
    int tmMaxCharWidth;
    int tmWeight;
    int tmOverhang;
    int tmDigitizedAspectX;
    int tmDigitizedAspectY;
    byte tmItalic;
    byte tmUnderlined;
    byte tmStruckOut;
    byte tmPitchAndFamily;
    byte tmCharSet;

    wchar tmFirstChar;
    wchar tmLastChar;
    wchar tmDefaultChar;
    wchar tmBreakChar;
}

struct TRIVERTEX {
    int x;
    int y;
    ushort Red;
    ushort Green;
    ushort Blue;
    ushort Alpha;
}

struct WINDOWPOS {
	int hwnd;                     
	int hwndInsertAfter;
	int x;                        
	int y;
	int cx;                       
	int cy;
	int flags;  
	static final int sizeof = 28;
}

struct WNDCLASS {
    int style;
    int lpfnWndProc;
    int cbClsExtra;
    int cbWndExtra;
    int hInstance;
    int hIcon;
    int hCursor;
    int hbrBackground;
    int lpszMenuName;
    int lpszClassName;
}


struct WINDOWPLACEMENT {
	int length;
	int flags; 
	int showCmd;
//	POINT ptMinPosition;
	int ptMinPosition_x;
	int ptMinPosition_y;
//	POINT ptMaxPosition;
	int ptMaxPosition_x;
	int ptMaxPosition_y;
//	RECT  rcNormalPosition; 
	int left;
	int top;
	int right;
	int bottom;
}




